local assets=
{
	Asset("ANIM", "anim/bonebat.zip"),
	Asset("ANIM", "anim/swap_bonebat.zip"),
	
	Asset( "ATLAS", "images/inventoryimages/bonebat.xml" ),
	Asset( "IMAGE", "images/inventoryimages/bonebat.tex" ),
    
}

local function onfinished(inst)
	inst.components.weapon:SetDamage(15)
end

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "swap_bonebat", "swap_spear")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

local function takefuel(inst)
	inst.level = inst.level + 1
	if inst.level > 9 then
		GetPlayer().components.inventory:GiveItem(SpawnPrefab("nightmarebonebat"))
		inst:Remove()
	end
end


local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
	
	inst.level = 0
    
    anim:SetBank("spear")
    anim:SetBuild("bonebat")
    anim:PlayAnimation("idle")
    
    inst:AddTag("sharp")

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(15)
	inst.components.weapon:SetName("bonebat")
    
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(1)
    inst.components.finiteuses:SetUses(1)
	
    inst.components.finiteuses:SetOnFinished( onfinished )

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/bonebat.xml"
	
	inst:AddComponent("fueled")
	inst.components.fueled.fueltype = "NIGHTMARE"
	inst.components.fueled.ontakefuelfn = takefuel
    inst.components.fueled.accepting = true
	inst.components.fueled.maxfuel = 100
	inst.components.fueled.currentfuel = 0
	
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    
	-- Charge until 100%, then deal triple damage and set percent to 0%
	local durability = inst.components.finiteuses
	inst:DoPeriodicTask(0.75, 
		function() 
			if inst.components.equippable.isequipped then
				if durability:GetPercent() < 1 then
					durability:SetPercent(durability:GetPercent() + 0.025)
				end
				if durability:GetPercent() >= 1 then
					durability:SetPercent(1)
					inst.components.weapon:SetDamage(45)
				end
			end
		end
	)
    return inst
end

return Prefab( "common/inventory/bonebat", fn, assets) 
