local assets=
{
	Asset("ANIM", "anim/bonecane.zip"),
	Asset("ANIM", "anim/swap_bonecane.zip"),
    
	Asset( "ATLAS", "images/inventoryimages/bonecane.xml" ),
	Asset( "IMAGE", "images/inventoryimages/bonecane.tex" ),
    
}

local function onfinished(inst)
    inst:Remove()
end

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "swap_bonecane", "swap_cane")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end


local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()        
    MakeInventoryPhysics(inst)
    
    anim:SetBank("cane")
    anim:SetBuild("bonecane")
    anim:PlayAnimation("idle")
    
    
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(TUNING.CANE_DAMAGE)
    
    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/bonecane.xml"
    
    inst:AddComponent("equippable")
    
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	
	local reignofgiants = IsDLCEnabled(REIGN_OF_GIANTS)
    local shipwrecked = IsDLCEnabled(CAPY_DLC)
	
	if shipwrecked then
		inst.components.equippable.walkspeedmult = 0.10
	else
		inst.components.equippable.walkspeedmult = 1.10
	end
    
    
    return inst
end


return Prefab( "common/inventory/bonecane", fn, assets) 

