local assets=
{
	Asset("ANIM", "anim/nightmarebonebat.zip"),
	Asset("ANIM", "anim/swap_nightmarebonebat.zip"),
	
	Asset( "ATLAS", "images/inventoryimages/nightmarebonebat.xml" ),
	Asset( "IMAGE", "images/inventoryimages/nightmarebonebat.tex" ),
    
}

local function onfinished(inst)
	inst.components.weapon:SetDamage(25)
end

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "swap_nightmarebonebat", "swap_spear")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end


local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    
    anim:SetBank("spear")
    anim:SetBuild("nightmarebonebat")
    anim:PlayAnimation("idle")
    
    inst:AddTag("sharp")

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(25)
	inst.components.weapon:SetName("nightmarebonebat")
    
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(1)
    inst.components.finiteuses:SetUses(1)
	
    inst.components.finiteuses:SetOnFinished( onfinished )

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/nightmarebonebat.xml"
	
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
    
	-- Charge until 100%, then deal triple damage and set percent to 0%
	local durability = inst.components.finiteuses
	inst:DoPeriodicTask(0.50, 
		function() 
			if inst.components.equippable.isequipped then
				if durability:GetPercent() < 1 then
					durability:SetPercent(durability:GetPercent() + 0.01)
					GetPlayer().components.sanity:DoDelta(-0.1, 0)
				end
				if durability:GetPercent() >= 1 then
					durability:SetPercent(1)
					inst.components.weapon:SetDamage(75)
				end
			end
		end
	)
    return inst
end

return Prefab( "common/inventory/nightmarebonebat", fn, assets) 
