local assets =
{ 
    Asset("ANIM", "anim/nightmarebonehelm.zip"),
    Asset("ANIM", "anim/nightmarebonehelm_swap.zip"),  

    Asset("ATLAS", "images/inventoryimages/nightmarebonehelm.xml"),
    Asset("IMAGE", "images/inventoryimages/nightmarebonehelm.tex"),
}

local prefabs = 
{
}

local function OnEquip(inst, owner) 
		inst.components.armor:SetName("nightmarebonehelm")
		inst.components.armor.equipped = true
        owner.AnimState:OverrideSymbol("swap_hat", "nightmarebonehelm_swap", "swap_hat")
        owner.AnimState:Show("HAT")
        owner.AnimState:Show("HAT_HAIR")
        owner.AnimState:Hide("HAIR_NOHAT")
        owner.AnimState:Hide("HAIR")
        
        if owner:HasTag("player") then
            owner.AnimState:Show("HEAD_HAIR")
        end
	
end

local function OnUnequip(inst, owner)
		inst.components.armor:SetName(" ")
		inst.components.armor.equipped = false
        owner.AnimState:ClearOverrideSymbol("swap_hat")
        owner.AnimState:Hide("HAT")
        owner.AnimState:Hide("HAT_HAIR")
        owner.AnimState:Show("HAIR_NOHAT")
        owner.AnimState:Show("HAIR")

        if owner:HasTag("player") then
            owner.AnimState:Show("HEAD")
            owner.AnimState:Hide("HEAD_HAIR")
        end
end



local function fn()

    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("footballhat")
    inst.AnimState:SetBuild("nightmarebonehelm")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("hat")

    inst:AddComponent("inspectable")
    inst:AddComponent("tradable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.imagename = "nightmarebonehelm"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/nightmarebonehelm.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
    inst.components.equippable:SetOnEquip(OnEquip)
    inst.components.equippable:SetOnUnequip(OnUnequip)
	
    inst:AddComponent("armor")
	local armorComp = inst.components.armor
    armorComp:InitCondition(1, 100)
	armorComp:SetName("nightmarebonehelm")
	inst.tag = "nightmarebonehelm"

	-- Regenerate durability up until 100% when equipped, at which point the armor will take one free hit and reduce back down to 0% durability
	inst:DoPeriodicTask(0.25, 
		function() 
			if armorComp.equipped then
				if armorComp:GetPercent() < 1 then
					-- The absorbtion effect will only take place once it reaches 1
					armorComp:SetAbsorption(armorComp:GetPercent() + 0.025)
					armorComp:SetPercent(armorComp:GetPercent() + 0.025)
				end
				if armorComp:GetPercent() > 1 then
					armorComp:SetPercent(1)
				end
			end
		end
	)
    return inst
end




return  Prefab("common/inventory/nightmarebonehelm", fn, assets, prefabs)