local assets=
{
	Asset("ANIM", "anim/nightmarefuel.zip"),
}

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("nightmarefuel")
    inst.AnimState:SetBuild("nightmarefuel")
    inst.AnimState:PlayAnimation("idle_loop", true)
    inst.AnimState:SetMultColour(1, 1, 1, 0.5)
    
    inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM    
    inst:AddComponent("inspectable")
    inst:AddComponent("fuel")
    inst.components.fuel.fueltype = "NIGHTMARE"
    inst.components.fuel.fuelvalue = TUNING.LARGE_FUEL

    inst:AddComponent("inventoryitem")
    
	-- Make nightmare fuel edible
	inst:AddComponent("edible")
	-- Cough cough, *edible*
    inst.components.edible.foodtype = "NIGHTMAREFUEL"
	-- By edible, I mean NOT safe to eat
	inst.components.edible.healthvalue = -15
	-- Nightmare fuel dissolves stomach contents ("what stomach, he's a skeleton!" "listen here you little shit")
    inst.components.edible.hungervalue = -25
	-- Yeah freak the fuck out from sanity
    inst.components.edible.sanityvalue = -50
	
	return inst
end

return Prefab( "common/inventory/nightmarefuel", fn, assets) 
